public class Parades {

	private int[][] c;
	private String[][] lcsMatrix;

	private int biggest;
	private String seqX, seqY, lcs;

	public Parades(String seqX, String seqY){
		this.seqX = seqX;
		this.seqY = seqY;
	}

	public void calcLCS(){
		int seqYLength = seqY.length(),
			seqXLength = seqX.length();
		c = new int[seqYLength+1][seqXLength+1];
		lcsMatrix = new String[seqYLength+1][seqXLength+1];

		fillLCSMatrix(seqXLength, seqYLength);
	}

	public String getLCS() {
		return lcs;
	}

	public int getBiggest() {
		return biggest;
	}

	//Matriz[y][x]
	public void fillLCSMatrix(int seqXLength, int seqYLength) {
		for(int i = 0; i <= seqYLength; i++)
			lcsMatrix[i][0] = "";

		for(int j = 0; j <= seqXLength; j++)
			lcsMatrix[0][j] = "";

		for (int i = 1; i <= seqYLength; i++) {
			for (int j = 1; j <= seqXLength; j++) {
				if (seqX.charAt(j - 1) == seqY.charAt(i - 1)) {
					c[i][j] = 1 + c[i - 1][j - 1];

					if(c[i-1][j] > c[i][j-1])
						lcsMatrix[i][j] = lcsMatrix[i-1][j];
					else if(c[i][j-1] < c[i-1][j])
						lcsMatrix[i][j] = lcsMatrix[i][j-1];
					else{
						lcsMatrix[i][j] = lcsMatrix[i-1][j-1] + seqX.charAt(j-1);
					}

				} else if (c[i - 1][j] > c[i][j - 1]) {
					c[i][j] = c[i - 1][j];

					lcsMatrix[i][j] = lcsMatrix[i-1][j];

				} else if (c[i - 1][j] < c[i][j - 1]) {
					c[i][j] = c[i][j - 1];

					lcsMatrix[i][j] = lcsMatrix[i][j-1];
				} else {
					c[i][j] = c[i-1][j];

					lcsMatrix[i][j] = lcsMatrix[i-1][j].compareTo(lcsMatrix[i][j-1]) < 0 ?
							lcsMatrix[i-1][j]
							: lcsMatrix[i][j-1];
				}
			}
		}
		biggest = c[seqYLength][seqXLength];
		lcs = lcsMatrix[seqYLength][seqXLength];
	}

	public void printMatrix(){
		System.out.println("c:");
		for (int a = 0; a < c.length; a++) {
			for (int b = 0; b < c[0].length; b++) {
				System.out.print(c[a][b]);
			}
			System.out.println();
		}
	}
}
