import java.util.LinkedList;
import java.util.Queue;

@SuppressWarnings("unchecked")
public class JackOLantern {

	private int width, height;
	private int[][] grid;
	private boolean[][] visited;

	public JackOLantern(int width, int height){
		this.width = width;
		this.height = height;
		grid = new int[height][width]; //[linha][coluna]
		visited = new boolean[height][width];
	}

	private class State{
		protected int lantern;
		protected int x, y;

		State(int lantern, int x, int y){
			this.lantern = lantern;
			this.x = x;
			this.y = y;
		}
	}

	public void addLine(String[] lineElement, int line){
		for(int col = 0; col < width; col++)
			if(lineElement[col].equals("*"))
				grid[line][col] = -1;
			else
				grid[line][col] = Integer.parseInt(lineElement[col]);
	}

	public int solve(){
		Queue<State> ready = new LinkedList();
		int result = 0, counter;

		if(grid[0][0] == -1){
			ready.add(new State(0, 1, 0));
			ready.add(new State(0, 0, 1));
		} else if(grid[0][0] != 0){
			ready.add(new State(grid[0][0] - 1 , 1, 0));
			ready.add(new State(grid[0][0] - 1, 0, 1));
		} else {
			if(grid[0][1] == -1)
				ready.add(new State(0, 1, 0));

			if(grid[1][0] == -1)
				ready.add(new State(0, 0, 1));
		}

		if(ready.isEmpty()) {
			System.out.println("here");
			return -1;
		}
		result++;
		counter = ready.size();

		int numIter = 0;

		for(;;){
			numIter++;
			if(ready.isEmpty()) break;
//			System.out.println(ready.size());
			State currState = ready.remove();

			if(currState.x == width - 1 && currState.y == height-1){
				System.out.printf("res: %d, num Iterations: %d\n", result, numIter);
				return result;
			}

			int x = currState.x,
				y = currState.y;
			visited[y][x] = true;

			if(grid[y][x] > currState.lantern) { //Se houver uma lanterna na posicao atual
//				System.out.println("currState:"+currState.lantern);
//				System.out.println("grid lantern:" + grid[y][x]);
				currState.lantern = grid[y][x];
				grid[y][x] = 0; //Garantee that it doesnt use the lantern again
			}

			if(grid[y][x] == -1){
				if(x < width - 1 && (currState.lantern > 0 || !visited[y][x+1]))
					ready.add(new State(currState.lantern, x+1, y));

				if(y < height - 1 && (currState.lantern > 0 || !visited[y+1][x]))
					ready.add(new State(currState.lantern, x, y+1));

				if(x > 0 && (currState.lantern > 0 || !visited[y][x-1]))
					ready.add(new State(currState.lantern, x-1, y));

				if(y > 0 && (currState.lantern > 0 ||  !visited[y-1][x]))
					ready.add(new State(currState.lantern, x, y-1));

			} else if(currState.lantern > 0) { //Se existe uma lampada na posicao
				if(x < width - 1)
					ready.add(new State(currState.lantern - 1, x+1, y));

				if(y < height - 1 )
					ready.add(new State(currState.lantern - 1, x, y+1));

				if(x > 0)
					ready.add(new State(currState.lantern - 1, x-1, y));

				if(y > 0)
					ready.add(new State(currState.lantern - 1, x, y-1));
			} else {
				if(x < width - 1 && (grid[y][x+1] == -1 && !visited[y][x+1]))
					ready.add(new State(currState.lantern, x+1, y));

				if(y < height - 1 && (grid[y+1][x] == -1 && !visited[y+1][x]))
					ready.add(new State(currState.lantern, x, y+1));

				if(x > 0 && (grid[y][x-1] == -1 && !visited[y][x-1]))
					ready.add(new State(currState.lantern, x-1, y));

				if(y > 0 && (grid[y-1][x] == -1 && !visited[y-1][x]))
					ready.add(new State(currState.lantern, x, y-1));
			}

			if(--counter == 0){
				result++;
				counter = ready.size();
			}
		}


		return -1;
	}
}